require 'active_model'

module ActiveRpc
  class Operation
    include ActiveModel::Model
    include ActiveModel::Validations
    include ActiveModel::Validations::Callbacks

    class << self
      def fields(*names)
        attr_accessor(*names)
      end

      def operation_name(value)
        ActiveRpc.operation_map[value] = self
      end
    end

    def call
      raise 'Must Implement'
    end
  end
end
